#ifndef XDPMI_H_
#define XDPMI_H_

struct register_data {
	unsigned long rd_edi;
	unsigned long rd_esi;
	unsigned long rd_ebp;
	unsigned long reserved;
	unsigned long rd_ebx;
	unsigned long rd_edx;
	unsigned long rd_ecx;
	unsigned long rd_eax;
	unsigned short rd_flags;
	unsigned short rd_es;
	unsigned short rd_ds;
	unsigned short rd_fs;
	unsigned short rd_gs;
	unsigned short rd_ip;
	unsigned short rd_cs;
	unsigned short rd_sp;
	unsigned short rd_ss;
};



typedef void __interrupt (*INT_FUNC)();
typedef void (*REAL_FUNC)();

int dos_alloc(unsigned short sz, unsigned short *sel, unsigned short *seg);
int dos_free(unsigned short sel);

int set_real_handler(unsigned char, INT_FUNC);
int sim_rm_intr(unsigned char, struct register_data *);
int rm_proc_retf(REAL_FUNC, struct register_data *);

void dpmi_error(unsigned short err_code, int fatal);

#endif
